#include <avr/io.h>             
#include <buttons.h>


volatile unsigned char _b1_cnt;
volatile unsigned char _b2_cnt;


BUTTON _button_press;


void BtnInit(void)
{
	_b1_cnt = 128;
	_b2_cnt = 128;

	// PB4/PB5 - als Eingang definieren
	DDRB &=~(1<<4);
	DDRB &=~(1<<5);
	
	// PB4/PB5 - PullUps aktivieren
	PORTB |= (1<<4);
	PORTB |= (1<<5);


}



/*****************************************************************************
 * Function: BtnProcessEvents
 *
 * Preconditon: BtnInit has to be called bevor using this function
 *
 * Overview: Must be called periodically to proccess buttons.
 *
 * Input: None.
 *
 * Output: None.
 *
 *****************************************************************************/
void BtnProcessEvents(void)
{
	if (!BUTTON1) {
		_b1_cnt++;
		if (_b1_cnt > (128 + BUTTON_MAX_DEBOUCE)){
			_b1_cnt = (128 + BUTTON_MAX_DEBOUCE);
			_button_press.b1 = 1;
		}		
	}
	else {
		_b1_cnt--;
		if (_b1_cnt < (128 - BUTTON_MAX_DEBOUCE)){
			_b1_cnt = (128 - BUTTON_MAX_DEBOUCE);
			_button_press.b1 = 0;
		}
	}
 

	if (!BUTTON2) {
		_b2_cnt++;
		if (_b2_cnt > (128 + BUTTON_MAX_DEBOUCE)){
			_b2_cnt = (128 + BUTTON_MAX_DEBOUCE);
			_button_press.b2 = 1;
		}
	}
	else {
		_b2_cnt--;
		if (_b2_cnt < (128 - BUTTON_MAX_DEBOUCE)){
			_b2_cnt = (128 - BUTTON_MAX_DEBOUCE);
			_button_press.b2 = 0;
		}
	}
}
