#include <avr/io.h>             
#include <avr/interrupt.h>
#include <timer.h>
#include <ad.h>
#include <es_seek.h>


volatile unsigned char delay_time_100us;
volatile unsigned char delay_time_1ms;
volatile unsigned char delay_time_10ms;
/*****************************************************************************
 * Function: Prog_100us
 *
 * Preconditon: None.
 *
 * Overview:
 *
 * Input: None.
 *
 * Output: None.
 *
 *****************************************************************************/	
void Prog_100us()
{
	AD_StateMachine();
	delay_time_100us--;
}

/*****************************************************************************
 * Function: Prog_1ms
 *
 * Preconditon: None.
 *
 * Overview:
 *
 * Input: None.
 *
 * Output: None.
 *
 *****************************************************************************/	
void Prog_1ms()
{
	delay_time_1ms--;
	ElectronicSeek_Statemachine();
}

/*****************************************************************************
 * Function: Prog_10ms
 *
 * Preconditon: None.
 *
 * Overview:
 *
 * Input: None.
 *
 * Output: None.
 *
 *****************************************************************************/	
void Prog_10ms()
{
	
	delay_time_10ms--;
}

/*****************************************************************************
 * Function: Timer_Init
 *
 * Preconditon: None.
 *
 * Overview:
 *
 * Input: None.
 *
 * Output: None.
 *
 *****************************************************************************/	
void Timer_Init()
{
	

	TCCR0 = 2;
	TCNT0 = 155;
	TIMSK = 2;
	
}

/*****************************************************************************
 * Function: TIMER0_OVF_vect
 *
 * Preconditon: None.
 *
 * Overview:
 *
 * Input: None.
 *
 * Output: None.
 *
 *****************************************************************************/	
ISR(TIMER0_OVF0_vect)
{
	
	static unsigned char counter_1;
	static unsigned char counter_2;
	unsigned char Status;

	Status = SREG;
	Timer_Init();
	Prog_100us();		// wird jede 0,1ms aufgerufen
	counter_1++;
	if (counter_1 < 10)
	{
		SREG = Status;
		return;
	}
	Prog_1ms();			// Wird jede ms aufgerufen
	counter_1 = 0;
	counter_2++;
	if (counter_2 < 10)
	{
		SREG = Status;
		return;
	}
	Prog_10ms();		// Wird alle 10ms aufgerufen
	counter_2 = 0;

	SREG = Status;
	return;	
}
